package io.chino.c3isp.buffermanager.restapi.types.datalake.mysql;

import org.passay.CharacterData;
import org.passay.CharacterRule;
import org.passay.EnglishCharacterData;
import org.passay.PasswordGenerator;

/**
 * Class that generates a password which complies to the specified criteria.
 * This class requires the use of <a href="https://www.passay.org/">Passay 1.3.1</a>.
 * Add it to your project's dependencies: <br>
 *
 * <pre><code>
 * &lt;dependency&gt;
 *       &lt;groupId&gt;org.passay&lt;/groupId&gt;
 *       &lt;artifactId&gt;passay&lt;/artifactId&gt;
 *       &lt;version&gt;1.3.1&lt;/version&gt;
 * &lt;/dependency&gt;
 * </code></pre>
 */
public class SecureCredentialsGenerator {

    /**
     * The special characters that must be used in passwords generated by this class
     */
    public static final CharacterData SPECIAL_CHARS = new CharacterData() {
        public String getCharacters() {
            return "-._~*()";
        }

        public String getErrorCode() {
            return "Special characters not found. Allowed chars are: " + getCharacters();
        }
    };

    /**
     * Default constraints for the generated passwords. Can be overwritten using {@link #withConstraints(int, int, int, int, int, int)}
     */
    private int mixedCase = 0,
    upperCount = mixedCase,
    lowerCount = mixedCase,
    specialCount = 0,
    digitCount = 0,
    length = 8;

    /**
     * Set the constraints for the passwords generated by this {@link SecureCredentialsGenerator}.
     *
     * @param mixed the minimum number of uppercase AND lowercase chars that must be in the password.
     *              <br> Default value is 0
     * @param upper the minimum number of uppercase chars that must be in the password.
     *              This value is ignored if lower than {@code mixed}.
     *              <br> Default value is 0
     * @param lower the minimum number of lowercase chars that must be in the password
     *              This value is ignored if lower than {@code mixed}.
     *              <br> Default value is 0
     * @param special the minimum number of special chars that must be in the password.
     *                Allowed special chars are defined in {@link #SPECIAL_CHARS}.
     *                <br> Default value is 0
     * @param number the minimum number of numbers that must be in the password.
     *               <br> Default value is 0
     * @param length the length of the generated password.
     *               <br> Default value is 8
     *
     * @return this instance of {@link SecureCredentialsGenerator}
     */
    public SecureCredentialsGenerator withConstraints(int mixed, int upper, int lower, int special, int number, int length) {
        this.upperCount = (mixed > upper) ? mixed : upper;
        this.lowerCount = (mixed > lower) ? mixed : lower;
        this.specialCount = special;
        this.digitCount = number;
        this.length = length;

        return this;
    }

    /**
     * Build a password that complies with the defined constraints.
     * You can set constraints by calling {@link #withConstraints(int, int, int, int, int, int)}.
     *
     * @return
     */
    public String getPassword() {
        PasswordGenerator gen = new PasswordGenerator();
        CharacterData lowerCaseChars = EnglishCharacterData.LowerCase;
        CharacterRule lowerCaseRule = new CharacterRule(lowerCaseChars);
        lowerCaseRule.setNumberOfCharacters(lowerCount);

        CharacterData upperCaseChars = EnglishCharacterData.UpperCase;
        CharacterRule upperCaseRule = new CharacterRule(upperCaseChars);
        upperCaseRule.setNumberOfCharacters(upperCount);

        CharacterData digitChars = EnglishCharacterData.Digit;
        CharacterRule digitRule = new CharacterRule(digitChars);
        digitRule.setNumberOfCharacters(digitCount);

        CharacterRule specialRule = new CharacterRule(SPECIAL_CHARS);
        specialRule.setNumberOfCharacters(specialCount);

        return gen.generatePassword(length, specialRule, lowerCaseRule, upperCaseRule, digitRule);
    }
}
